/* -*- c++ -*-
 * __BEGIN_COPYRIGHT
 * SimpleDB API
 * 
 * Copyright (C) 2005 Eminence Technology Pty Ltd
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You can view the GNU Lesser General Public Licence at
 * http://www.gnu.org/licenses/lgpl.html or you can write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Eminence Technology Pty Ltd can be contacted by writing to
 * Eminence Technology, PO Box 118, Moorooka QLD 4105, Australia.
 * Alternatively, you may email opensource [at] eminence [dot] com [dot] au
 * __END_COPYRIGHT
 */

#ifndef __SIMPLEDB_EXCEPTION_H_
#define __SIMPLEDB_EXCEPTION_H_

#include <exception>
#include <string>

namespace SimpleDB {

  /** SimpleDB Exception base class.
   */
  class Exception : public std::exception {
  public:
    
    /** Constructor
     *
     * @param message Message passed to the string class
     */
    Exception(const std::string& message) throw();
    
    /** Used to access the exceptions error.
     */
    const char* what() const throw();
    
    /** The exception message.
     */
    std::string message;

    /** Destructor. Currently does nothing.
     */
    virtual ~Exception() throw();

  };
}

#endif
